package br.com.stoneage.identify.identify_sdk_flutter

import br.com.stoneage.identify.identify_sdk_flutter.models.plugins.IIdentifySdkPluginCore
import br.com.stoneage.identify.identify_sdk_flutter.models.plugins.IIdentifySdkPluginDeviceInformation
import br.com.stoneage.identify.identify_sdk_flutter.models.plugins.IIdentifySdkPluginDocument
import br.com.stoneage.identify.identify_sdk_flutter.models.plugins.IIdentifySdkPluginOcr
import br.com.stoneage.identify.identify_sdk_flutter.models.plugins.IIdentifySdkPluginSelfie
import br.com.stoneage.identify.identify_sdk_flutter.plugins.IdentifySdkPluginCore
import br.com.stoneage.identify.identify_sdk_flutter.plugins.IdentifySdkPluginDeviceInformation
import br.com.stoneage.identify.identify_sdk_flutter.plugins.IdentifySdkPluginDocument
import br.com.stoneage.identify.identify_sdk_flutter.plugins.IdentifySdkPluginOcr
import br.com.stoneage.identify.identify_sdk_flutter.plugins.IdentifySdkPluginSelfie
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding

class IdentifySdkFlutterPlugin : FlutterPlugin, ActivityAware {

    private var mIdentifySdkPluginCore: IdentifySdkPluginCore? = null
    private var mIdentifySdkPluginDocument: IdentifySdkPluginDocument? = null
    private var mIdentifySdkPluginSelfie: IdentifySdkPluginSelfie? = null
    private var mIdentifySdkPluginOcr: IdentifySdkPluginOcr? = null
    private var mIdentifySdkPluginDeviceInformation: IdentifySdkPluginDeviceInformation? = null

    override fun onAttachedToEngine(flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        //CORE
        mIdentifySdkPluginCore = IdentifySdkPluginCore(flutterPluginBinding.applicationContext)
        IIdentifySdkPluginCore.setUp(flutterPluginBinding.binaryMessenger, mIdentifySdkPluginCore)

        //DOCUMENT
        mIdentifySdkPluginDocument =
            IdentifySdkPluginDocument(flutterPluginBinding.applicationContext)
        IIdentifySdkPluginDocument.setUp(
            flutterPluginBinding.binaryMessenger,
            mIdentifySdkPluginDocument
        )

        //SELFIE
        mIdentifySdkPluginSelfie = IdentifySdkPluginSelfie(flutterPluginBinding.applicationContext)
        IIdentifySdkPluginSelfie.setUp(
            flutterPluginBinding.binaryMessenger,
            mIdentifySdkPluginSelfie
        )

        //OCR
        mIdentifySdkPluginOcr = IdentifySdkPluginOcr()
        IIdentifySdkPluginOcr.setUp(flutterPluginBinding.binaryMessenger, mIdentifySdkPluginOcr)

        //DEVICE INFORMATION
        mIdentifySdkPluginDeviceInformation = IdentifySdkPluginDeviceInformation()
        IIdentifySdkPluginDeviceInformation.setUp(
            flutterPluginBinding.binaryMessenger,
            mIdentifySdkPluginDeviceInformation
        )
    }

    override fun onDetachedFromEngine(flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        mIdentifySdkPluginCore = null
        mIdentifySdkPluginDocument = null
        mIdentifySdkPluginSelfie = null
        mIdentifySdkPluginOcr = null
        mIdentifySdkPluginDeviceInformation = null
    }

    override fun onAttachedToActivity(activityPluginBinding: ActivityPluginBinding) {
        mIdentifySdkPluginDocument?.let {
            it.activity = activityPluginBinding.activity
        }

        mIdentifySdkPluginSelfie?.let {
            it.activity = activityPluginBinding.activity
        }

        mIdentifySdkPluginDeviceInformation?.let {
            it.activity = activityPluginBinding.activity
        }
    }

    override fun onDetachedFromActivityForConfigChanges() {
        mIdentifySdkPluginDocument?.let {
            it.activity = null
        }

        mIdentifySdkPluginSelfie?.let {
            it.activity = null
        }

        mIdentifySdkPluginDeviceInformation?.let {
            it.activity = null
        }
    }

    override fun onReattachedToActivityForConfigChanges(activityPluginBinding: ActivityPluginBinding) {
        mIdentifySdkPluginDocument?.let {
            it.activity = activityPluginBinding.activity
        }

        mIdentifySdkPluginSelfie?.let {
            it.activity = activityPluginBinding.activity
        }

        mIdentifySdkPluginDeviceInformation?.let {
            it.activity = activityPluginBinding.activity
        }
    }

    override fun onDetachedFromActivity() {
        mIdentifySdkPluginDocument?.let {
            it.activity = null
        }

        mIdentifySdkPluginSelfie?.let {
            it.activity = null
        }

        mIdentifySdkPluginDeviceInformation?.let {
            it.activity = null
        }
    }
}
