package br.com.stoneage.identify.identify_sdk_flutter.codecs

import br.com.stoneage.identify.identify_sdk_flutter.models.IdentifyTheme
import io.flutter.plugin.common.StandardMessageCodec
import java.io.ByteArrayOutputStream
import java.nio.ByteBuffer

object IdentifySdkPluginCoreCodec : StandardMessageCodec() {
    override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
        return when (type) {
            128.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    IdentifyTheme.fromList(it)
                }
            }

            else -> super.readValueOfType(type, buffer)
        }
    }

    override fun writeValue(stream: ByteArrayOutputStream, value: Any?) {
        when (value) {
            is IdentifyTheme -> {
                stream.write(128)
                writeValue(stream, value.toList())
            }

            else -> super.writeValue(stream, value)
        }
    }
}