package br.com.stoneage.identify.identify_sdk_flutter.codecs

import br.com.stoneage.identify.identify_sdk_flutter.errors.CollectDocumentError
import br.com.stoneage.identify.identify_sdk_flutter.errors.IdentifyError
import br.com.stoneage.identify.identify_sdk_flutter.models.BoundingBox
import br.com.stoneage.identify.identify_sdk_flutter.models.CollectDocumentResult
import br.com.stoneage.identify.identify_sdk_flutter.models.DocumentCropping
import br.com.stoneage.identify.identify_sdk_flutter.models.DocumentInfo
import br.com.stoneage.identify.identify_sdk_flutter.models.DocumentOptionalValidations
import br.com.stoneage.identify.identify_sdk_flutter.models.DocumentOptionalValidationsOcr
import br.com.stoneage.identify.identify_sdk_flutter.models.DocumentOptionalValidationsResult
import io.flutter.plugin.common.StandardMessageCodec
import java.io.ByteArrayOutputStream
import java.nio.ByteBuffer

object IdentifySdkPluginDocumentCodec : StandardMessageCodec() {
    override fun readValueOfType(type: Byte, buffer: ByteBuffer): Any? {
        return when (type) {
            128.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    BoundingBox.fromList(it)
                }
            }
            129.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    CollectDocumentError.fromList(it)
                }
            }
            130.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    CollectDocumentResult.fromList(it)
                }
            }
            131.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    DocumentCropping.fromList(it)
                }
            }
            132.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    DocumentInfo.fromList(it)
                }
            }
            133.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    DocumentOptionalValidations.fromList(it)
                }
            }
            134.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    DocumentOptionalValidationsOcr.fromList(it)
                }
            }
            135.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    DocumentOptionalValidationsResult.fromList(it)
                }
            }
            136.toByte() -> {
                return (readValue(buffer) as? List<Any?>)?.let {
                    IdentifyError.fromList(it)
                }
            }
            else -> super.readValueOfType(type, buffer)
        }
    }
    override fun writeValue(stream: ByteArrayOutputStream, value: Any?)   {
        when (value) {
            is BoundingBox -> {
                stream.write(128)
                writeValue(stream, value.toList())
            }
            is CollectDocumentError -> {
                stream.write(129)
                writeValue(stream, value.toList())
            }
            is CollectDocumentResult -> {
                stream.write(130)
                writeValue(stream, value.toList())
            }
            is DocumentCropping -> {
                stream.write(131)
                writeValue(stream, value.toList())
            }
            is DocumentInfo -> {
                stream.write(132)
                writeValue(stream, value.toList())
            }
            is DocumentOptionalValidations -> {
                stream.write(133)
                writeValue(stream, value.toList())
            }
            is DocumentOptionalValidationsOcr -> {
                stream.write(134)
                writeValue(stream, value.toList())
            }
            is DocumentOptionalValidationsResult -> {
                stream.write(135)
                writeValue(stream, value.toList())
            }
            is IdentifyError -> {
                stream.write(136)
                writeValue(stream, value.toList())
            }
            else -> super.writeValue(stream, value)
        }
    }
}