package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.BiometricValidationProbabilityEnum as NativeEnum

enum class BiometricValidationProbabilityEnum(val raw: Int) {
    HIGHEST(0),
    HIGH(1),
    LOW(2),
    LOWEST(3);

    companion object {
        fun ofRaw(raw: Int): BiometricValidationProbabilityEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(result: NativeEnum?): BiometricValidationProbabilityEnum? {
            return when (result) {
                NativeEnum.HIGHEST -> HIGHEST
                NativeEnum.HIGH -> HIGH
                NativeEnum.LOW -> LOW
                NativeEnum.LOWEST -> LOWEST
                else -> null
            }
        }
    }
}