package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.CameraCaptureModeEnum as NativeEnum

enum class DocumentCaptureModeEnum(val raw: Int) {
    MANUAL(0),
    AUTOMATIC(1);

    fun toNativeCaptureMode(): NativeEnum {
        return when (this) {
            MANUAL -> NativeEnum.MANUAL
            AUTOMATIC -> NativeEnum.AUTOMATIC
        }
    }

    companion object {
        fun ofRaw(raw: Int): DocumentCaptureModeEnum? {
            return values().firstOrNull { it.raw == raw }
        }
    }
}