package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.DocumentClassification as NativeEnum

enum class DocumentClassificationEnum(val raw: Int) {
    RG_FRENTE(0),
    RG_VERSO(1),
    CNH_FRENTE(2),
    CNH_VERSO(3),
    RGNOVO_FRENTE(4),
    RGNOVO_VERSO(5),
    RNE_FRENTE(6),
    RNE_VERSO(7),
    CIN_FRENTE(8),
    CIN_VERSO(9),
    UNKNOWN_DOCUMENT(10);

    companion object {
        fun ofRaw(raw: Int): DocumentClassificationEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(result: NativeEnum?): DocumentClassificationEnum? {
            return result?.let {
                when (it) {
                    NativeEnum.RG_FRENTE -> RG_FRENTE
                    NativeEnum.RG_VERSO -> RG_VERSO
                    NativeEnum.CNH_FRENTE -> CNH_FRENTE
                    NativeEnum.CNH_VERSO -> CNH_VERSO
                    NativeEnum.RGNOVO_FRENTE -> RGNOVO_FRENTE
                    NativeEnum.RGNOVO_VERSO -> RGNOVO_VERSO
                    NativeEnum.RNE_FRENTE -> RNE_FRENTE
                    NativeEnum.RNE_VERSO -> RNE_VERSO
                    NativeEnum.CIN_FRENTE -> CIN_FRENTE
                    NativeEnum.CIN_VERSO -> CIN_VERSO
                    NativeEnum.UNKNOWN_DOCUMENT -> UNKNOWN_DOCUMENT
                }
            }
        }
    }
}