package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.DocumentSideEnum as NativeEnum

enum class DocumentSideEnum(val raw: Int) {
    DOCUMENT_FRONT(0),
    DOCUMENT_BACK(1);

    companion object {
        fun ofRaw(raw: Int): DocumentSideEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(result: NativeEnum?): DocumentSideEnum? {
            return result?.let {
                when (it) {
                    NativeEnum.DocumentFront -> DOCUMENT_FRONT
                    NativeEnum.DocumentBack -> DOCUMENT_BACK
                }
            }
        }
    }
}