package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.DocumentType as NativeEnum

enum class DocumentTypeEnum(val raw: Int) {
    RG(0),
    CNH(1),
    RNE(2),
    CIN(3),
    UNKNOWN_DOCUMENT(4),
    MULTIPLE_DOCUMENTS(5),
    NO_DOCUMENT(6);

    companion object {
        fun ofRaw(raw: Int): DocumentTypeEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(nativeEnum: NativeEnum?): DocumentTypeEnum? {
            return when (nativeEnum) {
                NativeEnum.RG -> RG
                NativeEnum.CNH -> CNH
                NativeEnum.RNE -> RNE
                NativeEnum.CIN -> CIN
                NativeEnum.MULTIPLE_DOCUMENTS -> MULTIPLE_DOCUMENTS
                NativeEnum.NO_DOCUMENT -> NO_DOCUMENT
                null -> null
                else -> UNKNOWN_DOCUMENT
            }
        }
    }
}