package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.DocumentValidationError as NativeEnum

enum class DocumentValidationErrorEnum(val raw: Int) {
    IMAGE_NOT_GOOD_ENOUGH(0),
    DOCUMENT_NOT_DETECTED(1),
    NO_FACE_DETECTED(2),
    TOO_MANY_FACES(3),
    DOCUMENT_FRONT_DETECTED(4),
    DOCUMENT_BACK_DETECTED(5),
    DOCUMENT_DETECTION_FAILURE(6),
    NO_DOCUMENT_SIDE_DETECTED(7),
    MULTIPLE_DOCUMENTS(8),
    CROPPED_DOCUMENT(9),
    OPENED_DOCUMENT(10),
    DOCUMENT_TYPE_NOT_ALLOWED(11),
    FACE_IS_SMILING(12),
    UNKNOWN_ERROR(13);

    companion object {
        fun ofRaw(raw: Int): DocumentValidationErrorEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(result: NativeEnum): DocumentValidationErrorEnum {
            return when (result) {
                NativeEnum.IMAGE_NOT_GOOD_ENOUGH -> IMAGE_NOT_GOOD_ENOUGH
                NativeEnum.DOCUMENT_NOT_DETECTED -> DOCUMENT_NOT_DETECTED
                NativeEnum.NO_FACE_DETECTED -> NO_FACE_DETECTED
                NativeEnum.TOO_MANY_FACES -> TOO_MANY_FACES
                NativeEnum.DOCUMENT_FRONT_DETECTED -> DOCUMENT_FRONT_DETECTED
                NativeEnum.DOCUMENT_BACK_DETECTED -> DOCUMENT_BACK_DETECTED
                NativeEnum.DOCUMENT_DETECTION_FAILURE -> DOCUMENT_DETECTION_FAILURE
                NativeEnum.NO_DOCUMENT_SIDE_DETECTED -> NO_DOCUMENT_SIDE_DETECTED
                NativeEnum.MULTIPLE_DOCUMENTS -> MULTIPLE_DOCUMENTS
                NativeEnum.CROPPED_DOCUMENT -> CROPPED_DOCUMENT
                NativeEnum.OPENED_DOCUMENT -> OPENED_DOCUMENT
                NativeEnum.DOCUMENT_TYPE_NOT_ALLOWED -> DOCUMENT_TYPE_NOT_ALLOWED
                NativeEnum.FACE_IS_SMILING -> FACE_IS_SMILING
                else -> UNKNOWN_ERROR
            }
        }
    }
}