package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.DocumentOcrStatusEnum as NativeEnum
enum class OcrStatusEnum(val raw: Int) {
    FINISHED(0),
    IN_PROGRESS(1),
    ERROR(2);

    companion object {
        fun ofRaw(raw: Int): OcrStatusEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(result: NativeEnum): OcrStatusEnum {
            return when (result) {
                NativeEnum.IN_PROGRESS -> IN_PROGRESS
                NativeEnum.FINISHED -> FINISHED
            }
        }
    }
}