package br.com.stoneage.identify.identify_sdk_flutter.enums

import br.com.stoneage.identify.enums.CollectSelfieValidationError as NativeEnum

enum class SelfieValidationErrorEnum(val raw: Int) {
    IMAGE_NOT_GOOD_ENOUGH(0),
    NO_FACE_DETECTED(1),
    TOO_MANY_FACES(2),
    TILTED_FACE(3),
    WEARING_HAT(4),
    WEARING_GLASSES(5),
    WEARING_READING_GLASSES(6),
    WEARING_MASK(7),
    FACE_NOT_CENTERED(8),
    FACE_TOO_FAR(9),
    FACE_IS_SMILING(10),
    FACE_TOO_CLOSE(11),
    FACE_TOO_BRIGHT(12),
    FACE_TOO_DARK(13),
    FACES_DO_NOT_MATCH(14),
    BIOMETRIC_VALIDATION_ERROR(15),
    LIVENESS_NOT_OK(16),
    UNKNOWN_ERROR(17);

    companion object {
        fun ofRaw(raw: Int): SelfieValidationErrorEnum? {
            return values().firstOrNull { it.raw == raw }
        }

        fun fromNativeEnum(result: NativeEnum): SelfieValidationErrorEnum {
            return when (result) {
                NativeEnum.IMAGE_NOT_GOOD_ENOUGH -> IMAGE_NOT_GOOD_ENOUGH
                NativeEnum.NO_FACE_DETECTED -> NO_FACE_DETECTED
                NativeEnum.TOO_MANY_FACES -> TOO_MANY_FACES
                NativeEnum.TILTED_FACE -> TILTED_FACE
                NativeEnum.WEARING_HAT -> WEARING_HAT
                NativeEnum.WEARING_GLASSES ->WEARING_GLASSES
                NativeEnum.WEARING_READING_GLASSES -> WEARING_READING_GLASSES
                NativeEnum.WEARING_MASK -> WEARING_MASK
                NativeEnum.FACE_NOT_CENTERED -> FACE_NOT_CENTERED
                NativeEnum.FACE_TOO_FAR -> FACE_TOO_FAR
                NativeEnum.FACE_IS_SMILING -> FACE_IS_SMILING
                NativeEnum.FACE_TOO_CLOSE -> FACE_TOO_CLOSE
                NativeEnum.FACE_TOO_BRIGHT -> FACE_TOO_BRIGHT
                NativeEnum.FACE_TOO_DARK -> FACE_TOO_DARK
                NativeEnum.FACES_DO_NOT_MATCH -> FACES_DO_NOT_MATCH
                NativeEnum.BIOMETRIC_VALIDATION_ERROR -> BIOMETRIC_VALIDATION_ERROR
                NativeEnum.LIVENESS_NOT_OK -> LIVENESS_NOT_OK
                else -> UNKNOWN_ERROR
            }
        }
    }
}