package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.models.PhoneInformation as NativeResult

/** Generated class from Pigeon that represents data sent in messages. */
data class AndroidOnlyDeviceInformation(
    val androidSdk: Int,
    val isProbablyAnEmulator: Boolean
) {
    companion object {
        fun fromList(list: List<Any?>): AndroidOnlyDeviceInformation {
            val androidSdk = list[0] as Int
            val isProbablyAnEmulator = list[1] as Boolean
            return AndroidOnlyDeviceInformation(androidSdk, isProbablyAnEmulator)
        }

        fun fromNativeResult(phoneInformation: NativeResult): AndroidOnlyDeviceInformation {
            return AndroidOnlyDeviceInformation(
                androidSdk = phoneInformation.systemSdk,
                isProbablyAnEmulator = phoneInformation.isProbablyAnEmulator,
            )
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            androidSdk,
            isProbablyAnEmulator,
        )
    }
}