package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.models.BoundingBox as NativeResult

/** Generated class from Pigeon that represents data sent in messages. */
data class BoundingBox(
    val centerX: Double,
    val centerY: Double,
    val height: Double,
    val width: Double
) {
    companion object {
        fun fromList(list: List<Any?>): BoundingBox {
            val centerX = list[0] as Double
            val centerY = list[1] as Double
            val height = list[2] as Double
            val width = list[3] as Double
            return BoundingBox(centerX, centerY, height, width)
        }

        fun fromNativeResult(result: NativeResult): BoundingBox {
            return BoundingBox(
                centerX = result.centerX,
                centerY = result.centerY,
                height = result.height,
                width = result.width,
            )
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            centerX,
            centerY,
            height,
            width,
        )
    }
}