package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.models.CollectSelfieParameters as NativeParameters

/** Generated class from Pigeon that represents data sent in messages. */
data class CollectSelfieParameters(
    val validateLiveness: Boolean? = false,
    val biometricValidationCpf: String? = null
) {
    companion object {
        fun fromList(list: List<Any?>): CollectSelfieParameters {
            val validateLiveness = list[0] as Boolean?
            val biometricValidationCpf = list[1] as String?
            return CollectSelfieParameters(validateLiveness, biometricValidationCpf)
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            validateLiveness,
            biometricValidationCpf,
        )
    }

    fun toNativeParameters(): NativeParameters {
        return NativeParameters(
            validateLiveness = validateLiveness ?: false,
            cpf = biometricValidationCpf
        )
    }
}