package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.models.CollectSelfieResult as NativeResult

/** Generated class from Pigeon that represents data sent in messages. */
data class CollectSelfieResult(
    val requestId: String,
    val selfie: SelfieInfo,
    val optionalValidations: SelfieOptionalValidations? = null
) {
    companion object {
        fun fromList(list: List<Any?>): CollectSelfieResult {
            val requestId = list[0] as String
            val selfie = SelfieInfo.fromList(list[1] as List<Any?>)
            val optionalValidations: SelfieOptionalValidations? = (list[2] as List<Any?>?)?.let {
                SelfieOptionalValidations.fromList(it)
            }
            return CollectSelfieResult(requestId, selfie, optionalValidations)
        }

        fun fromNativeResult(result: NativeResult): CollectSelfieResult {
            return CollectSelfieResult(
                requestId = result.requestId!!,
                selfie = SelfieInfo.fromNativeResult(result),
                optionalValidations = SelfieOptionalValidations.fromNativeResult(result.optionalValidations)
            )
        }
    }

    fun toList(): List<Any?> {
        return listOf(
            requestId,
            selfie.toList(),
            optionalValidations?.toList(),
        )
    }
}