package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.models.DocumentInfo as NativeResult

/** Generated class from Pigeon that represents data sent in messages. */
data class DocumentCropping(
    val success: Boolean,
    val isCropped: Boolean? = null,
    val confidence: Double? = null

) {
    companion object {
        fun fromList(list: List<Any?>): DocumentCropping {
            val success = list[0] as Boolean
            val isCropped = list[1] as Boolean?
            val confidence = list[2] as Double?
            return DocumentCropping(success, isCropped, confidence)
        }

        fun fromNativeResult(result: NativeResult): DocumentCropping {
            return DocumentCropping(
                success = result.isCroppingSuccess,
                isCropped = if (result.isCroppingSuccess) result.isCropped else null,
                confidence = if (result.isCroppingSuccess) result.confidence else null,
            )
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            success,
            isCropped,
            confidence,
        )
    }
}