package br.com.stoneage.identify.identify_sdk_flutter.models

import android.graphics.Color
import br.com.stoneage.identify.sdk.STAColor
import br.com.stoneage.identify.sdk.STATheme

data class IdentifyTheme(
    val primaryColor: String,
    val successColor: String,
    val neutralColor: String

) {
    fun toSTATheme(): STATheme {
        return STATheme(
            STAColor(Color.parseColor(this.primaryColor)),
            STAColor(Color.parseColor(this.successColor)),
            STAColor(Color.parseColor(this.neutralColor)),
        )
    }
    companion object {
        fun fromList(list: List<Any?>): IdentifyTheme {
            val primaryColor = list[0] as String
            val successColor = list[1] as String
            val neutralColor = list[2] as String
            return IdentifyTheme(primaryColor, successColor, neutralColor)
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            primaryColor,
            successColor,
            neutralColor,
        )

    }
}