package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.identify_sdk_flutter.utils.FileUtils
import java.io.File
import br.com.stoneage.identify.models.CollectSelfieResult as NativeResult

/** Generated class from Pigeon that represents data sent in messages. */
data class SelfieInfo(
    val image: String,
    val ageRange: AgeRange,
    val brightness: Double,
    val confidence: Double,
    val sharpness: Double
) {
    companion object {
        fun fromList(list: List<Any?>): SelfieInfo {
            val image = list[0] as String
            val ageRange = AgeRange.fromList(list[1] as List<Any?>)
            val brightness = list[2] as Double
            val confidence = list[3] as Double
            val sharpness = list[4] as Double
            return SelfieInfo(image, ageRange, brightness, confidence, sharpness)
        }

        fun fromNativeResult(result: NativeResult): SelfieInfo {
            return SelfieInfo(
                image = FileUtils.fileToBase64(result.file),
                ageRange = AgeRange.fromNativeResult(result.imageResult.ageRange),
                brightness = result.imageResult.brightness,
                confidence = result.imageResult.confidence,
                sharpness = result.imageResult.sharpness,
            )
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            image,
            ageRange.toList(),
            brightness,
            confidence,
            sharpness,
        )
    }
}