package br.com.stoneage.identify.identify_sdk_flutter.models

import br.com.stoneage.identify.models.OptionalValidations as NativeResult

data class SelfieOptionalValidations(
    val livenessResult: LivenessResult? = null,
    val biometricResult: BiometricResult? = null
) {
    companion object {
        fun fromList(list: List<Any?>): SelfieOptionalValidations {
            val livenessResult: LivenessResult? = (list[0] as List<Any?>?)?.let {
                LivenessResult.fromList(it)
            }
            val biometricResult: BiometricResult? = (list[1] as List<Any?>?)?.let {
                BiometricResult.fromList(it)
            }
            return SelfieOptionalValidations(livenessResult, biometricResult)
        }

        fun fromNativeResult(result: NativeResult?): SelfieOptionalValidations? {
            return result?.let {
                SelfieOptionalValidations(
                    livenessResult = LivenessResult.fromNativeResult(it.livenessResult),
                    biometricResult = BiometricResult.fromNativeResult(it.biometricResult),
                )
            }
        }
    }

    fun toList(): List<Any?> {
        return listOf<Any?>(
            livenessResult?.toList(),
            biometricResult?.toList(),
        )
    }
}