package br.com.stoneage.identify.identify_sdk_flutter.models.plugins

import br.com.stoneage.identify.identify_sdk_flutter.codecs.IdentifySdkPluginSelfieCodec
import br.com.stoneage.identify.identify_sdk_flutter.models.CollectSelfieParameters
import br.com.stoneage.identify.identify_sdk_flutter.models.CollectSelfieResult
import br.com.stoneage.identify.identify_sdk_flutter.plugins.IdentifySdkPluginSelfie
import br.com.stoneage.identify.identify_sdk_flutter.utils.WrappingUtils
import io.flutter.plugin.common.BasicMessageChannel
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MessageCodec

/** Generated interface from Pigeon that represents a handler of messages from Flutter. */
interface IIdentifySdkPluginSelfie {
    fun collect(
        parameters: CollectSelfieParameters?,
        callback: (Result<CollectSelfieResult>) -> Unit
    )

    companion object {
        /** The codec used by IIdentifySdkPluginSelfie. */
        private val codec: MessageCodec<Any?> by lazy {
            IdentifySdkPluginSelfieCodec
        }

        /** Sets up an instance of `IIdentifySdkPluginSelfie` to handle messages through the `binaryMessenger`. */
        fun setUp(binaryMessenger: BinaryMessenger, api: IIdentifySdkPluginSelfie?) {
            run {
                val channel = BasicMessageChannel<Any?>(
                    binaryMessenger,
                    "dev.flutter.pigeon.identify_sdk_flutter.IdentifySdkPluginSelfie.collect",
                    codec
                )
                if (api != null) {
                    channel.setMessageHandler { message, reply ->
                        val args = message as List<Any?>
                        val parametersArg = args[0] as CollectSelfieParameters?
                        api.collect(parametersArg) { result: Result<CollectSelfieResult> ->
                            val error = result.exceptionOrNull()
                            if (error != null) {
                                reply.reply(WrappingUtils.wrapError(error))
                            } else {
                                val data = result.getOrNull()
                                reply.reply(WrappingUtils.wrapResult(data))
                            }
                        }
                    }
                } else {
                    channel.setMessageHandler(null)
                }
            }
        }
    }
}
