package br.com.stoneage.identify.identify_sdk_flutter.plugins

import android.content.Context
import android.content.ContextWrapper
import android.graphics.Color
import br.com.stoneage.identify.identify_sdk_flutter.models.IdentifyTheme
import br.com.stoneage.identify.identify_sdk_flutter.models.plugins.IIdentifySdkPluginCore
import br.com.stoneage.identify.sdk.STAColor
import br.com.stoneage.identify.sdk.STATheme
import br.com.stoneage.identify.sdk.STAUserSession

class IdentifySdkPluginCore(private val context: Context) : IIdentifySdkPluginCore {
    override fun initializeSession(
        token: String,
        stage: String,
        theme: IdentifyTheme?,
        callback: (Result<Unit>) -> Unit
    ) {
        STAUserSession.initialize(
            stage,
            token,
            theme?.toSTATheme() ?: STATheme(),
            ContextWrapper(context)
        )

        callback(Result.success(Unit))
    }
}