package br.com.stoneage.identify.identify_sdk_flutter.utils

import android.content.Intent
import android.os.Build
import android.os.Parcelable

object IntentUtils {
    inline fun <reified T : Parcelable?> Intent.getParcelable(name: String): T? {
        return if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            this.getParcelableExtra(name, T::class.java)
        } else {
            this.getParcelableExtra<T>(name)
        }
    }
}