// Autogenerated from Pigeon (v16.0.5), do not edit directly.
// See also: https://pub.dev/packages/pigeon

import Foundation

#if os(iOS)
import Flutter
#elseif os(macOS)
import FlutterMacOS
#else
#error("Unsupported platform.")
#endif

private class IdentifySdkPluginDeviceInformationCodecReader: FlutterStandardReader {
    override func readValue(ofType type: UInt8) -> Any? {
        switch type {
//      NOTE: As the name suggests, this type correspond to Android only information. We don't need to handle it.
//        case 128:
//            return AndroidOnlyDeviceInformation.fromList(self.readValue() as! [Any?])
        case 129:
            return DeviceInformationResult.fromList(self.readValue() as! [Any?])
        case 130:
            return IdentifyException.fromList(self.readValue() as! [Any?])
        case 131:
            return IosOnlyDeviceInformation.fromList(self.readValue() as! [Any?])
        case 132:
            return LocationData.fromList(self.readValue() as! [Any?])
        default:
            return super.readValue(ofType: type)
        }
    }
}

private class IdentifySdkPluginDeviceInformationCodecWriter: FlutterStandardWriter {
    override func writeValue(_ value: Any) {
//      NOTE: As the name suggests, this type correspond to Android only information. We don't need to handle it.
//        if let value = value as? AndroidOnlyDeviceInformation {
//            super.writeByte(128)
//            super.writeValue(value.toList())
//        }

        if let value = value as? DeviceInformationResult {
            super.writeByte(129)
            super.writeValue(value.toList())
        } else if let value = value as? IdentifyException {
            super.writeByte(130)
            super.writeValue(value.toList())
        } else if let value = value as? IosOnlyDeviceInformation {
            super.writeByte(131)
            super.writeValue(value.toList())
        } else if let value = value as? LocationData {
            super.writeByte(132)
            super.writeValue(value.toList())
        } else {
            super.writeValue(value)
        }
    }
}

private class IdentifySdkPluginDeviceInformationCodecReaderWriter: FlutterStandardReaderWriter {
    override func reader(with data: Data) -> FlutterStandardReader {
        return IdentifySdkPluginDeviceInformationCodecReader(data: data)
    }

    override func writer(with data: NSMutableData) -> FlutterStandardWriter {
        return IdentifySdkPluginDeviceInformationCodecWriter(data: data)
    }
}

class IdentifySdkPluginDeviceInformationCodec: FlutterStandardMessageCodec {
    static let shared = IdentifySdkPluginDeviceInformationCodec(readerWriter: IdentifySdkPluginDeviceInformationCodecReaderWriter())
}

/// Generated setup class from Pigeon to handle messages through the `binaryMessenger`.
class IdentifySdkPluginDeviceInformationSetup {
    /// The codec used by IdentifySdkPluginDeviceInformation.
    static var codec: FlutterStandardMessageCodec { IdentifySdkPluginDeviceInformationCodec.shared }
    /// Sets up an instance of `IdentifySdkPluginDeviceInformation` to handle messages through the `binaryMessenger`.
    static func setUp(binaryMessenger: FlutterBinaryMessenger, api: IdentifySdkPluginDeviceInformation?) {
        let getDeviceInformationChannel = FlutterBasicMessageChannel(name: "dev.flutter.pigeon.identify_sdk_flutter.IdentifySdkPluginDeviceInformation.getDeviceInformation", binaryMessenger: binaryMessenger, codec: codec)
        if let api = api {
            getDeviceInformationChannel.setMessageHandler { message, reply in
                let args = message as! [Any?]
                let geolocationArg = args[0] as! Bool
                api.getDeviceInformation(geolocation: geolocationArg) { result in
                    switch result {
                    case .success(let res):
                        reply(WrappingUtils.wrapResult(res))
                    case .failure(let error):
                        reply(WrappingUtils.wrapError(error))
                    }
                }
            }
        } else {
            getDeviceInformationChannel.setMessageHandler(nil)
        }
    }
}
