import STAIdentify

extension STACollectSelfieSuccess {
    func toCollectSelfieResult() -> CollectSelfieResult {
        return CollectSelfieResult(requestId: self.requestId,
                                   selfie: self.toSelfieInfo(),
                                   optionalValidations: self.optionalValidations?.toSelfieOptionalValidations())
    }

    func toSelfieInfo() -> SelfieInfo {
        let imageResult = self.selfieImageResult

        return SelfieInfo(image: self.selfieImage.base64,
                          ageRange: imageResult.ageRange.toAgeRange(),
                          brightness: imageResult.brightness,
                          confidence: imageResult.confidence,
                          sharpness: imageResult.sharpness)
    }
}

extension STASelfieImageResult.STAAgeRange {
    func toAgeRange() -> AgeRange {
        return AgeRange(min: Int64(self.min), max: Int64(self.max))
    }
}

