import STAIdentify

extension STAFaceValidationError {
    func toSelfieValidationErrorEnum() -> SelfieValidationErrorEnum {
        switch self {
        case .biometricValidationError:
            return .biometricValidationError
        case .imageNotGoodEnough:
            return .imageNotGoodEnough
        case .noFaceDetected:
            return .noFaceDetected
        case .tooManyFaces:
            return .tooManyFaces
        case .tiltedFace:
            return .tiltedFace
        case .wearingHeadwear:
            return .wearingHat
        case .wearingReadingGlasses:
            return .wearingReadingGlasses
        case .wearingGlasses:
            return .wearingGlasses
        case .wearingMask:
            return .wearingMask
        case .faceNotCentered:
            return .faceNotCentered
        case .faceTooFar:
            return .faceTooFar
        case .faceIsSmiling:
            return .faceIsSmiling
        case .faceTooClose:
            return .faceTooClose
        case .faceTooBright:
            return .faceTooBright
        case .faceTooDark:
            return .faceTooDark
        case .facesDoNotMatch:
            return .facesDoNotMatch
        case .ok:
            // TODO: We shoudn't have the case .ok in an error condition
            return .unknownError
        case .unknownError:
            return .unknownError
        case .wrongGesture:
            // NOTE: 'wrongGesture' cannot occur in a selfie validation. Therefore, we don't have a proper case to
            // map it to.
            return .unknownError
        }
    }
}
