/// Generated class from Pigeon that represents data sent in messages.
struct BiometricResult {
    var isAvailable: Bool
    var identityConfirmationProbability: BiometricValidationProbabilityEnum? = nil
    var serviceProviderAvailable: Bool? = nil
    var similarity: Double? = nil

    static func fromList(_ list: [Any?]) -> BiometricResult? {
        let isAvailable = list[0] as! Bool
        var identityConfirmationProbability: BiometricValidationProbabilityEnum? = nil
        let identityConfirmationProbabilityEnumVal: Int? = WrappingUtils.nilOrValue(list[1])
        if let identityConfirmationProbabilityRawValue = identityConfirmationProbabilityEnumVal {
            identityConfirmationProbability = BiometricValidationProbabilityEnum(rawValue: identityConfirmationProbabilityRawValue)!
        }
        let serviceProviderAvailable: Bool? = WrappingUtils.nilOrValue(list[2])
        let similarity: Double? = WrappingUtils.nilOrValue(list[3])

        return BiometricResult(
            isAvailable: isAvailable,
            identityConfirmationProbability: identityConfirmationProbability,
            serviceProviderAvailable: serviceProviderAvailable,
            similarity: similarity
        )
    }

    func toList() -> [Any?] {
        return [
            isAvailable,
            identityConfirmationProbability?.rawValue,
            serviceProviderAvailable,
            similarity,
        ]
    }
}
