/// Generated class from Pigeon that represents data sent in messages.
struct CollectDocumentResult {
    var documentType: DocumentTypeEnum
    var documentInfo: [DocumentInfo?]
    var image: String
    var requestId: String
    var optionalValidations: DocumentOptionalValidationsResult? = nil

    static func fromList(_ list: [Any?]) -> CollectDocumentResult? {
        let documentType = DocumentTypeEnum(rawValue: list[0] as! Int)!
        let documentInfo = list[1] as! [DocumentInfo?]
        let image = list[2] as! String
        let requestId = list[3] as! String
        var optionalValidations: DocumentOptionalValidationsResult? = nil
        if let optionalValidationsList: [Any?] = WrappingUtils.nilOrValue(list[4]) {
            optionalValidations = DocumentOptionalValidationsResult.fromList(optionalValidationsList)
        }

        return CollectDocumentResult(
            documentType: documentType,
            documentInfo: documentInfo,
            image: image,
            requestId: requestId,
            optionalValidations: optionalValidations
        )
    }
    func toList() -> [Any?] {
        return [
            documentType.rawValue,
            documentInfo,
            image,
            requestId,
            optionalValidations?.toList(),
        ]
    }
}
