/// Generated class from Pigeon that represents data sent in messages.
struct DeviceInformationResult {
    var vendorId: String
    var deviceModel: String
    var manufacturer: String
    var systemName: String
    var usesMetricSystem: Bool
    var isRooted: Bool
    var timeZone: String
    var preferredLanguages: [String?]
    var carriers: [String?]
    var flutterSdkVersion: String? = nil
    var deviceStorage: String? = nil
    var currencyCode: String? = nil
    var location: LocationData? = nil
    var wiFiIp: String? = nil
    var publicIp: String? = nil
    var nativeSdkVersion: String? = nil
    // NOTE: This property is only present because Pigeon uses positional values, i.e., it expects
    // a list with 18 elements. Since we don't need to declare the AndroidOnlyDeviceInformation class,
    // this property has type Never?. Since a Never object cannot be constructed, this property will
    // always be null.
    var androidOnly: Never? = nil
    var iosOnly: IosOnlyDeviceInformation? = nil

    static func fromList(_ list: [Any?]) -> DeviceInformationResult? {
        let vendorId = list[0] as! String
        let deviceModel = list[1] as! String
        let manufacturer = list[2] as! String
        let systemName = list[3] as! String
        let usesMetricSystem = list[4] as! Bool
        let isRooted = list[5] as! Bool
        let timeZone = list[6] as! String
        let preferredLanguages = list[7] as! [String?]
        let carriers = list[8] as! [String?]
        let flutterSdkVersion: String? = WrappingUtils.nilOrValue(list[9])
        let deviceStorage: String? = WrappingUtils.nilOrValue(list[10])
        let currencyCode: String? = WrappingUtils.nilOrValue(list[11])
        var location: LocationData? = nil
        if let locationList: [Any?] = WrappingUtils.nilOrValue(list[12]) {
            location = LocationData.fromList(locationList)
        }

        let wiFiIp: String? = WrappingUtils.nilOrValue(list[13])
        let publicIp: String? = WrappingUtils.nilOrValue(list[14])
        let nativeSdkVersion: String? = WrappingUtils.nilOrValue(list[15])
        var androidOnly: Never? = nil

        var iosOnly: IosOnlyDeviceInformation? = nil
        if let iosOnlyList: [Any?] = WrappingUtils.nilOrValue(list[17]) {
            iosOnly = IosOnlyDeviceInformation.fromList(iosOnlyList)
        }

        return DeviceInformationResult(
            vendorId: vendorId,
            deviceModel: deviceModel,
            manufacturer: manufacturer,
            systemName: systemName,
            usesMetricSystem: usesMetricSystem,
            isRooted: isRooted,
            timeZone: timeZone,
            preferredLanguages: preferredLanguages,
            carriers: carriers,
            flutterSdkVersion: flutterSdkVersion,
            deviceStorage: deviceStorage,
            currencyCode: currencyCode,
            location: location,
            wiFiIp: wiFiIp,
            publicIp: publicIp,
            nativeSdkVersion: nativeSdkVersion,
            androidOnly: androidOnly,
            iosOnly: iosOnly
        )
    }

    func toList() -> [Any?] {
        return [
            vendorId,
            deviceModel,
            manufacturer,
            systemName,
            usesMetricSystem,
            isRooted,
            timeZone,
            preferredLanguages,
            carriers,
            flutterSdkVersion,
            deviceStorage,
            currencyCode,
            location?.toList(),
            wiFiIp,
            publicIp,
            nativeSdkVersion,
            androidOnly,
            iosOnly?.toList(),
        ]
    }
}
