/// Generated class from Pigeon that represents data sent in messages.
struct DocumentInfo {
    var confidence: Double
    var cropping: DocumentCropping
    var boundingBox: BoundingBox
    var classification: DocumentClassificationEnum? = nil
    var documentSide: DocumentSideEnum? = nil
    var documentName: String? = nil

    static func fromList(_ list: [Any?]) -> DocumentInfo? {
        let confidence = list[0] as! Double
        let cropping = DocumentCropping.fromList(list[1] as! [Any?])!
        let boundingBox = BoundingBox.fromList(list[2] as! [Any?])!
        var classification: DocumentClassificationEnum? = nil
        let classificationEnumVal: Int? = WrappingUtils.nilOrValue(list[3])
        if let classificationRawValue = classificationEnumVal {
            classification = DocumentClassificationEnum(rawValue: classificationRawValue)!
        }
        var documentSide: DocumentSideEnum? = nil
        let documentSideEnumVal: Int? = WrappingUtils.nilOrValue(list[4])
        if let documentSideRawValue = documentSideEnumVal {
            documentSide = DocumentSideEnum(rawValue: documentSideRawValue)!
        }
        let documentName: String? = WrappingUtils.nilOrValue(list[5])

        return DocumentInfo(
            confidence: confidence,
            cropping: cropping,
            boundingBox: boundingBox,
            classification: classification,
            documentSide: documentSide,
            documentName: documentName
        )
    }

    func toList() -> [Any?] {
        return [
            confidence,
            cropping.toList(),
            boundingBox.toList(),
            classification?.rawValue,
            documentSide?.rawValue,
            documentName,
        ]
    }
}
