/// Generated class from Pigeon that represents data sent in messages.
struct CollectSelfieException: IdentifyNativeError {
    var code: IdentifyErrorCodeEnum = .collectSelfieValidationError
    var message: String
    var validationErrors: [SelfieValidationErrorEnum]? = nil
    var optionalValidations: SelfieOptionalValidations? = nil

    static func fromList(_ list: [Any?]) -> IdentifyNativeError? {
        let code = IdentifyErrorCodeEnum(rawValue: list[0] as! Int)!
        let message = list[1] as! String
        let validationErrors: [SelfieValidationErrorEnum]? = WrappingUtils.nilOrValue(list[2])
        var optionalValidations: SelfieOptionalValidations? = nil
        if let optionalValidationsList: [Any?] = WrappingUtils.nilOrValue(list[3]) {
            optionalValidations = SelfieOptionalValidations.fromList(optionalValidationsList)
        }

        return CollectSelfieException(
            code: code,
            message: message,
            validationErrors: validationErrors,
            optionalValidations: optionalValidations
        )
    }

    func toList() -> [Any?] {
        return [
            code.rawValue,
            message,
            validationErrors?.map { $0.rawValue },
            optionalValidations?.toList(),
        ]
    }
}
