/// Generated class from Pigeon that represents data sent in messages.
struct LocationData {
    var longitude: Double
    var latitude: Double
    var timestamp: Int64
    var altitude: Double? = nil
    var accuracy: Double? = nil
    var speed: Double? = nil
    var speedAccuracy: Double? = nil
    var bearing: Double? = nil
    var bearingAccuracy: Double? = nil

    static func fromList(_ list: [Any?]) -> LocationData? {
        let longitude = list[0] as! Double
        let latitude = list[1] as! Double
        let timestamp = list[2] is Int64 ? list[2] as! Int64 : Int64(list[2] as! Int32)
        let altitude: Double? = WrappingUtils.nilOrValue(list[3])
        let accuracy: Double? = WrappingUtils.nilOrValue(list[4])
        let speed: Double? = WrappingUtils.nilOrValue(list[5])
        let speedAccuracy: Double? = WrappingUtils.nilOrValue(list[6])
        let bearing: Double? = WrappingUtils.nilOrValue(list[7])
        let bearingAccuracy: Double? = WrappingUtils.nilOrValue(list[8])

        return LocationData(
            longitude: longitude,
            latitude: latitude,
            timestamp: timestamp,
            altitude: altitude,
            accuracy: accuracy,
            speed: speed,
            speedAccuracy: speedAccuracy,
            bearing: bearing,
            bearingAccuracy: bearingAccuracy
        )
    }
    func toList() -> [Any?] {
        return [
            longitude,
            latitude,
            timestamp,
            altitude,
            accuracy,
            speed,
            speedAccuracy,
            bearing,
            bearingAccuracy,
        ]
    }
}
