/// Generated class from Pigeon that represents data sent in messages.
struct OcrInfo {
    var expeditionDate: String? = nil
    var location: String? = nil
    var type: DocumentTypeEnum? = nil
    var issuanceDate: String? = nil
    var placeOfBirth: String? = nil
    var documentOrigin: String? = nil
    var ownerSigns: Bool? = nil
    var firstFiliation: String? = nil
    var secondFiliation: String? = nil
    var registerNumber: String? = nil
    var generalRegisterNumber: String? = nil
    var dateOfBirth: String? = nil
    var drivingLicenseCategory: String? = nil
    var fullName: String? = nil
    var drivingLicenseFirstIssuanceDate: String? = nil
    var cpf: String? = nil
    var expirationDate: String? = nil
    var expeditionIssuer: String? = nil
    var expeditionIssuerState: String? = nil
    var socialName: String? = nil
    var gender: String? = nil
    var nationality: String? = nil
    var classification: String? = nil
    var residencePeriod: String? = nil
    var surname: String? = nil

    static func fromList(_ list: [Any?]) -> OcrInfo? {
        let expeditionDate: String? = WrappingUtils.nilOrValue(list[0])
        let location: String? = WrappingUtils.nilOrValue(list[1])
        var type: DocumentTypeEnum? = nil
        let typeEnumVal: Int? = WrappingUtils.nilOrValue(list[2])
        if let typeRawValue = typeEnumVal {
            type = DocumentTypeEnum(rawValue: typeRawValue)!
        }
        let issuanceDate: String? = WrappingUtils.nilOrValue(list[3])
        let placeOfBirth: String? = WrappingUtils.nilOrValue(list[4])
        let documentOrigin: String? = WrappingUtils.nilOrValue(list[5])
        let ownerSigns: Bool? = WrappingUtils.nilOrValue(list[6])
        let firstFiliation: String? = WrappingUtils.nilOrValue(list[7])
        let secondFiliation: String? = WrappingUtils.nilOrValue(list[8])
        let registerNumber: String? = WrappingUtils.nilOrValue(list[9])
        let generalRegisterNumber: String? = WrappingUtils.nilOrValue(list[10])
        let dateOfBirth: String? = WrappingUtils.nilOrValue(list[11])
        let drivingLicenseCategory: String? = WrappingUtils.nilOrValue(list[12])
        let fullName: String? = WrappingUtils.nilOrValue(list[13])
        let drivingLicenseFirstIssuanceDate: String? = WrappingUtils.nilOrValue(list[14])
        let cpf: String? = WrappingUtils.nilOrValue(list[15])
        let expirationDate: String? = WrappingUtils.nilOrValue(list[16])
        let expeditionIssuer: String? = WrappingUtils.nilOrValue(list[17])
        let expeditionIssuerState: String? = WrappingUtils.nilOrValue(list[18])
        let socialName: String? = WrappingUtils.nilOrValue(list[19])
        let gender: String? = WrappingUtils.nilOrValue(list[20])
        let nationality: String? = WrappingUtils.nilOrValue(list[21])
        let classification: String? = WrappingUtils.nilOrValue(list[22])
        let residencePeriod: String? = WrappingUtils.nilOrValue(list[23])
        let surname: String? = WrappingUtils.nilOrValue(list[24])

        return OcrInfo(
            expeditionDate: expeditionDate,
            location: location,
            type: type,
            issuanceDate: issuanceDate,
            placeOfBirth: placeOfBirth,
            documentOrigin: documentOrigin,
            ownerSigns: ownerSigns,
            firstFiliation: firstFiliation,
            secondFiliation: secondFiliation,
            registerNumber: registerNumber,
            generalRegisterNumber: generalRegisterNumber,
            dateOfBirth: dateOfBirth,
            drivingLicenseCategory: drivingLicenseCategory,
            fullName: fullName,
            drivingLicenseFirstIssuanceDate: drivingLicenseFirstIssuanceDate,
            cpf: cpf,
            expirationDate: expirationDate,
            expeditionIssuer: expeditionIssuer,
            expeditionIssuerState: expeditionIssuerState,
            socialName: socialName,
            gender: gender,
            nationality: nationality,
            classification: classification,
            residencePeriod: residencePeriod,
            surname: surname
        )
    }
    
    func toList() -> [Any?] {
        return [
            expeditionDate,
            location,
            type?.rawValue,
            issuanceDate,
            placeOfBirth,
            documentOrigin,
            ownerSigns,
            firstFiliation,
            secondFiliation,
            registerNumber,
            generalRegisterNumber,
            dateOfBirth,
            drivingLicenseCategory,
            fullName,
            drivingLicenseFirstIssuanceDate,
            cpf,
            expirationDate,
            expeditionIssuer,
            expeditionIssuerState,
            socialName,
            gender,
            nationality,
            classification,
            residencePeriod,
            surname,
        ]
    }
}
