import STAIdentify

class IdentifySdkPluginCoreImpl: IdentifySdkPluginCore {
    func initializeSession(token: String,
                           stage: String,
                           theme: IdentifyTheme?,
                           completion: @escaping (Result<Void, Error>) -> Void) {
        let staStage = getStage(fromString: stage)
        let staTheme = IdentifyTheme.toSTATheme(theme)

        STAUserSession.initialize(withToken: token, andStage: staStage, theme: staTheme)

        completion(.success(()))
    }

    func getStage(fromString stageString: String) -> STAUserSession.STAStage {
        let stageLowercase = stageString.lowercased()
        switch stageLowercase {
        case "prod":
            return .prod
        case "hmg":
            return .hmg;
        default:
            return .dev(stageString)
        }
    }
}
