import STAIdentify

class IdentifySdkPluginDocumentImpl: IdentifySdkPluginDocument {
    func collect(documentSide: DocumentSideEnum,
                 captureMode: DocumentCaptureModeEnum?,
                 optionalValidations: DocumentOptionalValidations?,
                 completion: @escaping (Result<CollectDocumentResult, Error>) -> Void) {
        let documentViewController = STACollectDocument(documentSide: documentSide.toSTADocumentSide(),
                                                        captureMode: captureMode?.toSTACaptureMode() ?? .manual,
                                                        startOcrValidation: optionalValidations?.doOcr ?? false)

        documentViewController.didCompleteCollectDocument { result in
            switch result {
            case .success(let documentSuccess):
                completion(.success(documentSuccess.toCollectDocumentResult()))
            case .failure(let error):
                completion(.failure(error.mapToNativeError()))
            }
        }

        DispatchQueue.main.async {
            if let rootVC = ViewControllerUtils.rootViewController {
                rootVC.present(documentViewController, animated: true)
            }
        }
    }
}
