internal struct ViewControllerUtils {
    private init() { }

    // NOTE: Trying different solutions from this [thread](https://github.com/flutter/flutter/issues/25078)
    //       until we find a valid ViewController.
    static var rootViewController: UIViewController? {
        get {
            let visibleWindows = UIApplication.shared.windows.filter { $0.isHidden == false }

            if let rootViewController = visibleWindows.first?.rootViewController {
                return rootViewController
            }

            if let rootViewController = UIApplication.shared.keyWindow?.rootViewController {
                return rootViewController
            }

            if let rootViewController = UIApplication.shared.delegate?.window??.rootViewController {
                return rootViewController
            }

            return nil
        }
    }
}
