#if os(iOS)
import Flutter
#elseif os(macOS)
import FlutterMacOS
#else
#error("Unsupported platform.")
#endif

internal struct WrappingUtils {
    private init() {
    }

    internal static func wrapResult(_ result: Any?) -> [Any?] {
        return [result]
    }

    internal static func wrapError(_ error: Any) -> [Any?] {
        if let flutterError = error as? FlutterError {
            return [
                flutterError.code,
                flutterError.message,
                flutterError.details
            ]
        }
        return [
            "\(error)",
            "\(type(of: error))",
            error
        ]
    }

    internal static func isNullish(_ value: Any?) -> Bool {
        return value is NSNull || value == nil
    }

    internal static func nilOrValue<T>(_ value: Any?) -> T? {
        if value is NSNull { return nil }
        return value as! T?
    }
}
