import 'package:flutter/services.dart';

import '../models/identify_theme.dart';

/// @nodoc
class IdentifySdkPluginCoreCodec extends StandardMessageCodec {
  /// @nodoc
  const IdentifySdkPluginCoreCodec();

  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is IdentifyTheme) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return IdentifyTheme.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}
