import 'package:flutter/services.dart';

import '../exceptions/all.dart';
import '../models/all.dart';

/// @nodoc
class IdentifySdkPluginDeviceInformationCodec extends StandardMessageCodec {
  /// @nodoc
  const IdentifySdkPluginDeviceInformationCodec();

  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AndroidOnlyDeviceInformation) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is DeviceInformationResult) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is IdentifyException) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is IosOnlyDeviceInformation) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is LocationData) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return AndroidOnlyDeviceInformation.decode(readValue(buffer)!);
      case 129:
        return DeviceInformationResult.decode(readValue(buffer)!);
      case 130:
        return IdentifyException.decode(readValue(buffer)!);
      case 131:
        return IosOnlyDeviceInformation.decode(readValue(buffer)!);
      case 132:
        return LocationData.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}
