import 'package:flutter/services.dart';

import '../exceptions/all.dart';
import '../models/all.dart';

/// @nodoc
class IdentifySdkPluginDocumentCodec extends StandardMessageCodec {
  /// @nodoc
  const IdentifySdkPluginDocumentCodec();

  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is BoundingBox) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is CollectDocumentException) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is CollectDocumentResult) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is DocumentCropping) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is DocumentInfo) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is DocumentOptionalValidations) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is DocumentOptionalValidationsOcr) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is DocumentOptionalValidationsResult) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is IdentifyException) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return BoundingBox.decode(readValue(buffer)!);
      case 129:
        return CollectDocumentException.decode(readValue(buffer)!);
      case 130:
        return CollectDocumentResult.decode(readValue(buffer)!);
      case 131:
        return DocumentCropping.decode(readValue(buffer)!);
      case 132:
        return DocumentInfo.decode(readValue(buffer)!);
      case 133:
        return DocumentOptionalValidations.decode(readValue(buffer)!);
      case 134:
        return DocumentOptionalValidationsOcr.decode(readValue(buffer)!);
      case 135:
        return DocumentOptionalValidationsResult.decode(readValue(buffer)!);
      case 136:
        return IdentifyException.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}
