import 'package:flutter/services.dart';

import '../exceptions/all.dart';
import '../models/all.dart';

/// @nodoc
class IdentifySdkPluginOcrCodec extends StandardMessageCodec {
  /// @nodoc
  const IdentifySdkPluginOcrCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is CollectOcrResult) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is IdentifyException) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is OcrInfo) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return CollectOcrResult.decode(readValue(buffer)!);
      case 129:
        return IdentifyException.decode(readValue(buffer)!);
      case 130:
        return OcrInfo.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}
