import 'package:flutter/services.dart';

import '../exceptions/all.dart';
import '../models/all.dart';

/// @nodoc
class IdentifySdkPluginSelfieCodec extends StandardMessageCodec {
  /// @nodoc
  const IdentifySdkPluginSelfieCodec();

  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AgeRange) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is BiometricResult) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is CollectSelfieException) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is CollectSelfieParameters) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is CollectSelfieResult) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is IdentifyException) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is LivenessResult) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is SelfieInfo) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is SelfieOptionalValidations) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return AgeRange.decode(readValue(buffer)!);
      case 129:
        return BiometricResult.decode(readValue(buffer)!);
      case 130:
        return CollectSelfieException.decode(readValue(buffer)!);
      case 131:
        return CollectSelfieParameters.decode(readValue(buffer)!);
      case 132:
        return CollectSelfieResult.decode(readValue(buffer)!);
      case 133:
        return IdentifyException.decode(readValue(buffer)!);
      case 134:
        return LivenessResult.decode(readValue(buffer)!);
      case 135:
        return SelfieInfo.decode(readValue(buffer)!);
      case 136:
        return SelfieOptionalValidations.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}
