/// Classification of the document and its corresponding side according to the
/// model for selection within the image.
enum DocumentClassificationEnum {
  /// Front side of RG document - side with the user’s photo.
  rgFrente,

  /// Back side of RG document - opposite side to the user’s photo.
  rgVerso,

  /// Front side of CNH document - side with the user’s photo.
  cnhFrente,

  /// Back side of CNH document - opposite side to the user’s photo.
  cnhVerso,

  /// Front side of the new RG document model - side with the user’s photo.
  rgNovoFrente,

  /// Back side of the new RG document model - opposite side to the user’s photo.
  rgNovoVerso,

  /// Front side of the Brazilian national migration registration document CRNM - side with the user’s photo.
  rneFrente,

  /// Back side of the Brazilian national migration registration document CRNM - opposite side to the user’s photo.
  rneVerso,

  /// Front side of CIN document - side with the user’s photo.
  cinFrente,

  /// Back side of CIN document - opposite side to the user’s photo.
  cinVerso,

  /// A document was detected in the image, but it is of an unknown type.
  unknownDocument,
}
