/// All Identify Error Codes.
enum IdentifyErrorCodeEnum {
  /// The user chose to cancel the feature execution.
  canceledByUser,

  /// The token used in session is invalid or expired.
  invalidSession,

  /// @nodoc
  invalidGesturesNumber,

  /// The server returned an unexpected response.
  apiError,

  /// The device does not have a camera or it is unavailable.
  cameraUnavailable,

  /// @nodoc
  liveSelfieValidationError,

  /// @nodoc
  digitalDocumentValidationError,

  /// An error was detected while validating the document photo.
  collectDocumentValidationError,

  /// There was a connection Error. Probably the user doesn't have internet access.
  connectionError,

  /// The user denied requested permission.
  permissionDenied,

  /// The device's GPS is disabled.
  gpsDisabled,

  /// There was an error collecting GPS location.
  gpsError,

  /// The was a problem collecting the public IP.
  publicIpProblem,

  /// There was an error on Verify Phone Number or Verify Email.
  oneTimeCodeError,

  /// An error was detected while validating the selfie photo.
  collectSelfieValidationError,

  /// The CPF passed for validation is invalid or incorrect.
  invalidCpf,

  /// There was an error while trying to obtain an OCR response. The most probable cause is an invalid OCR request ID.
  collectOcrError,
}
