import '../enums/all.dart';

/// An error that can occur during the execution of any Identify feature.
class IdentifyException implements Exception {
  /// @nodoc
  IdentifyException({
    required this.code,
    required this.message,
  });

  /// A code describing the error.
  IdentifyErrorCodeEnum code;

  /// A human-readable description of the error.
  ///
  /// This property should not be used to identify the error. If you need to identify the error, use [code] instead.
  String message;

  /// @nodoc
  Object encode() {
    return <Object?>[
      code.index,
      message,
    ];
  }

  /// @nodoc
  static IdentifyException decode(Object result) {
    result as List<Object?>;
    return IdentifyException(
      code: IdentifyErrorCodeEnum.values[result[0]! as int],
      message: result[1]! as String,
    );
  }
}
