/// The age range of a face detected on an image.
class AgeRange {
  /// @nodoc
  AgeRange({
    required this.min,
    required this.max,
  });

  ///The minimum age for the face according to the detection model.
  int min;

  ///The maximum age for the face according to the detection model.
  int max;

  /// @nodoc
  Object encode() {
    return <Object?>[
      min,
      max,
    ];
  }

  /// @nodoc
  static AgeRange decode(Object result) {
    result as List<Object?>;
    return AgeRange(
      min: result[0]! as int,
      max: result[1]! as int,
    );
  }
}
