/// Device information available only on Android devices.
class AndroidOnlyDeviceInformation {
  /// @nodoc
  AndroidOnlyDeviceInformation({
    required this.androidSdk,
    required this.isProbablyAnEmulator,
  });

  /// The Android SDK version used by the device.
  int androidSdk;

  /// Whether the app is running on an emulator. We can't guarantee with 100%
  /// certainty that the device is an emulator.
  bool isProbablyAnEmulator;

  /// @nodoc
  Object encode() {
    return <Object?>[
      androidSdk,
      isProbablyAnEmulator,
    ];
  }

  /// @nodoc
  static AndroidOnlyDeviceInformation decode(Object result) {
    result as List<Object?>;
    return AndroidOnlyDeviceInformation(
      androidSdk: result[0]! as int,
      isProbablyAnEmulator: result[1]! as bool,
    );
  }
}
