/// Bounding box of the document in the image.
class BoundingBox {
  /// @nodoc
  BoundingBox({
    required this.centerX,
    required this.centerY,
    required this.height,
    required this.width,
  });

  /// Document's center X axis coordinate. Range between 0 and 1.
  double centerX;

  /// Document's center Y axis coordinate. Range between 0 and 1.
  double centerY;

  /// Document's height. Range between 0 and 1.
  double height;

  /// Document's width. Range between 0 and 1.
  double width;

  /// @nodoc
  Object encode() {
    return <Object?>[
      centerX,
      centerY,
      height,
      width,
    ];
  }

  /// @nodoc
  static BoundingBox decode(Object result) {
    result as List<Object?>;
    return BoundingBox(
      centerX: result[0]! as double,
      centerY: result[1]! as double,
      height: result[2]! as double,
      width: result[3]! as double,
    );
  }
}
