/// Class that represents all parameters for [collectSelfie] request.
class CollectSelfieParameters {
  /// @nodoc
  CollectSelfieParameters({
    this.validateLiveness,
    this.biometricValidationCpf,
  });

  /// Whether execute passive liveness.
  bool? validateLiveness;

  /// CPF for biometric validation.
  String? biometricValidationCpf;

  /// @nodoc
  Object encode() {
    return <Object?>[
      validateLiveness,
      biometricValidationCpf,
    ];
  }

  /// @nodoc
  static CollectSelfieParameters decode(Object result) {
    result as List<Object?>;
    return CollectSelfieParameters(
      validateLiveness: result[0] as bool?,
      biometricValidationCpf: result[1] as String?,
    );
  }
}
