/// Cropping Information of the document.
class DocumentCropping {
  /// @nodoc
  DocumentCropping({
    required this.success,
    this.isCropped,
    this.confidence,
  });

  /// Flag that indicates if the cropped document detection was executed with success
  bool success;

  /// Flag that indicates if the document is cropped.
  bool? isCropped;

  /// Confidence if the document is cropped or not. Range between 0 and 1.
  double? confidence;

  /// @nodoc
  Object encode() {
    return <Object?>[
      success,
      isCropped,
      confidence,
    ];
  }

  /// @nodoc
  static DocumentCropping decode(Object result) {
    result as List<Object?>;
    return DocumentCropping(
      success: result[0]! as bool,
      isCropped: result[1] as bool?,
      confidence: result[2] as double?,
    );
  }
}
