/// Class that represents all optional validations for a [collectDocument]
/// request
class DocumentOptionalValidations {
  /// @nodoc
  DocumentOptionalValidations({
    required this.doOcr,
  });

  /// Whether to perform OCR validation on the document.
  bool doOcr;

  /// @nodoc
  Object encode() {
    return <Object?>[
      doOcr,
    ];
  }

  /// @nodoc
  static DocumentOptionalValidations decode(Object result) {
    result as List<Object?>;
    return DocumentOptionalValidations(
      doOcr: result[0]! as bool,
    );
  }
}
