import 'all.dart';

/// Interface that represents all optional validations requested during a Selfie
/// validation.
class SelfieOptionalValidations {
  /// @nodoc
  SelfieOptionalValidations({
    this.livenessResult,
    this.biometricResult,
  });

  /// Liveness validation info.
  LivenessResult? livenessResult;

  /// Biometric validation info.
  BiometricResult? biometricResult;

  /// @nodoc
  Object encode() {
    return <Object?>[
      livenessResult?.encode(),
      biometricResult?.encode(),
    ];
  }

  /// @nodoc
  static SelfieOptionalValidations decode(Object result) {
    result as List<Object?>;
    return SelfieOptionalValidations(
      livenessResult: result[0] != null
          ? LivenessResult.decode(result[0]! as List<Object?>)
          : null,
      biometricResult: result[1] != null
          ? BiometricResult.decode(result[1]! as List<Object?>)
          : null,
    );
  }
}
