// ignore_for_file: public_member_api_docs

import 'package:flutter/services.dart';
import 'package:identify_sdk_flutter/identify_sdk_flutter.dart';

import '../codecs/all.dart';

class IdentifySdkPluginOcr {
  /// Constructor for [IdentifySdkPluginOcr].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  IdentifySdkPluginOcr({BinaryMessenger? binaryMessenger})
      : pigeonBinaryMessenger = binaryMessenger;
  final BinaryMessenger? pigeonBinaryMessenger;

  static const MessageCodec<Object?> pigeonChannelCodec =
      IdentifySdkPluginOcrCodec();

  Future<CollectOcrResult> collect(String requestId) async {
    const String pigeonChannelName =
        'dev.flutter.pigeon.identify_sdk_flutter.IdentifySdkPluginOcr.collect';
    final BasicMessageChannel<Object?> pigeonChannel =
        BasicMessageChannel<Object?>(
      pigeonChannelName,
      pigeonChannelCodec,
      binaryMessenger: pigeonBinaryMessenger,
    );
    final List<Object?>? pigeonReplyList =
        await pigeonChannel.send(<Object?>[requestId]) as List<Object?>?;
    if (pigeonReplyList == null) {
      throw ConnectionException(pigeonChannelName);
    } else if (pigeonReplyList.length > 1) {
      throw PlatformException(
        code: pigeonReplyList[0]! as String,
        message: pigeonReplyList[1] as String?,
        details: pigeonReplyList[2],
      );
    } else if (pigeonReplyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (pigeonReplyList[0] as CollectOcrResult?)!;
    }
  }
}
